

#include<pic.h>
#include"delay.h"
#include"lcd.h"

unsigned row,col,rd; 
static int a[]={0,0,0,0,0};
unsigned int pwd,pwd1,e=5,count=0,ad,lock=1,k=0; 
void rowfind(int); /*prototype declaration of a function that identifies row*/
void rdd(int); /*prototype declaration ofa function that assigns rd=RDX*/
void action(); /*prototype declaration of a function that performs the action allotted to a key*/
int pwdread(); /*prototype declaration of a function that reads pasword*/  
void pwdwrite(int);/*prototype declaration ofa function that writes password*/
unsigned readbyte(unsigned);/*prototype declaration ofa function that reads a byte from EEPROM*/
void writebyte(unsigned,unsigned);/*prototype declaration ofa function that writes a byte to EEPROM*/


void main()
{
unsigned x;
TRISB=0xF0; //PORTB lower half declared as output port and upper half as input port
PORTB=0x0F; //PORTB cleared
TRISC=0xF0; //PORTC upper i/p lower o/p    
PORTC=0x00; //PORTC initialized with 0Fh  
TRISD=0X00;
PORTD=0;
pwd1=pwdread(); //pasword read from EEPROM
lcd_init(); //LCD initialized
lcd_goto(0); //LCD address specified
lcd_puts("Welcome"); //Displays message "Welcome"
while(1)
{
x=PORTB; //contents of PORTB assigned to x
switch(x) //To find column
{
case 0x1F:
{
col=1;
rowfind(1); //call of function to identify row
}
break;
case 0x2F:
{
col=2;
rowfind(2);
}
break;
case 0x4F:
{
col=3;
rowfind(3);
}
break;
case 0x8F:
{
col=4;
rowfind(4);
}
break;

default:
{
row=0;
col=0;
}
break;
}
if(row !=0 &&col !=0)
{
action(); //call of action()
while(1) //wait until key is released
{
if (PORTB==0x0F)
break;
}
DelayMs(20); //Key debouncing
}
}
}

void rowfind(int y) //definition of rowfind(int)
{

DelayMs(20); //Key debouncing
if(PORTB==0x0F)
return;
RB3=0;
rdd(y);
if(rd==0)
{
row=1;
RB3=1;
return;
}
RB3=1;
RB2=0;
rdd(y);
if(rd==0)
{
row=2;
RB2=1;
return;
}
RB2=1;
RB1=0;
rdd(y);
if(rd==0)
{
row=3;
RB1=1;
return;
}
RB1=1;
RB0=0;
rdd(y);
if(rd==0)
row=4;
RB0=1;
}

void rdd(int y) //definition of rdd(int)
{
switch(y)
{
case 1:
rd=RB4;
break;
case 2:
rd=RB5;
break;
case 3:
rd=RB6;
break;
case 4:
rd=RB7;
break;
}
}


int pwdread()  //Definition of pwdwrite()
{
int z;
unsigned x,y;
x=readbyte(0x00);//read EEPROM address 0x00
y=readbyte(0x01);//read EEPROM address 0x01
if(x>99 || y>99)
{
pwdwrite(1234); //set default password in case of first time use
z=1234;
}
else
{
z=x*100+y;
}

return z;
}

void pwdwrite(int p)//definition of pwdwrite()
{
unsigned  x,y;
x=p/100;
y=p%100;
writebyte(0x00,x); // write a byte to EEPROM address 0x00
writebyte(0x01,y); //write byte to EEPROM address 0x01
}

unsigned readbyte(unsigned rdaddr) //Definition of readbyte()
{
unsigned  byte;                     // Variable hold the data that is read

	EEADR = rdaddr;                        // Read from this address

	EEPGD = 0;                              // Point to EE memory
	RD	  = 1;                              // Initiate a read cycle

	byte = EEDATA;                          // Fetch byte from dataregister
	return byte;      
}

void writebyte(unsigned rwaddr, unsigned data)//Definition of writebyte()
{
    EEADR  = rwaddr;                       // Address to write to
	EEDATA = data;                          // Data to write

	WREN   = 1;                             // Enable writes to the EEProm
	GIE    = 0;                             // Disable interrupts during write
    EEPGD=0;    

	EECON2 = 0x55;                          // Write "password" to EECON2
	EECON2 = 0xAA;
	WR     = 1;                             // Initiate a write cycle

	while(!EEIF);                           // Wait for write to complete
	WREN   = 0;                             // Disable writes to EEProm
	EEIF   = 0;
}

void action() //definition of action()
{
if(row==1 && col==1)
{
if(count!=0)
{
a[count]=1;
lcd_putch('*');
ad++;
count--;
}
}
if(row==1 && col==2)
{
if(count!=0)
{
a[count]=2;
lcd_putch('*');
ad++;
count--;
}
}
if(row==1 && col==3)
{
if(count!=0)
{
a[count]=3;
lcd_putch('*');
ad++;
count--;
}
}
if(row==2 && col==1)
{
if(count!=0)
{
a[count]=4;
lcd_putch('*');
ad++;
count--;
}
}
if(row==2 && col==2)
{
if(count!=0)
{
a[count]=5;
lcd_putch('*');
ad++;
count--;
}
}
if(row==2 && col==3)
{
if(count!=0)
{
a[count]=6;
lcd_putch('*');
ad++;
count--;
}
}
if(row==2 && col==4)
{
if(count==0)
{
RC2=0;   //RB0=0;
for(int i=0;i<5;i++)
a[i]=0;
e=5;
lock=1;
lcd_clear();
lcd_goto(0);
lcd_puts("Lock Closed");
}
}
if(row==3 && col==1)
{
if(count!=0)
{
a[count]=7;
lcd_putch('*');
ad++;
count--;
}
}
if(row==3 && col==2)
{
if(count!=0)
{
a[count]=8;
lcd_putch('*');
ad++;
count--;
}
}
if(row==3 && col==3)
{
if(count!=0)
{
a[count]=9;
lcd_putch('*');
ad++;
count--;
}
}
if(row==3 && col==4)
{
ad=0x44;
count=4;
e=0;
lcd_clear();
lcd_goto(0);
lcd_puts("Current password");
lcd_goto(ad);
}
if(row==4 && col==1)
{
if(e==0 || e==1 || e==2)
{
if(count>=0 && ad>0x44)
{
ad--;
if(count<=4)
count++;
lcd_goto(ad);
lcd_puts(" ");
lcd_goto(ad);
}
}
}
if(row==4 && col==2)
{
if(count!=0)
{
a[count]=0;
lcd_putch('*');
ad++;
count--;
}
}
if(row==4 && col==3)
{
if(count==0)
{
pwd=a[4]*1000+a[3]*100+a[2]*10+a[1];
if(e==1)
{
if(pwd==pwd1)
{
e=5;
lock=0;
lcd_clear();
lcd_goto(0);
lcd_puts("Password Accepted");
RC2=1;
DelayMs(2000);
lcd_clear();
lcd_goto(0);
lcd_puts("Lock Open");
}
else
{
lock=1;
e=5;
lcd_clear();
lcd_goto(0);
lcd_puts("Password Denied");
DelayMs(2000);
lcd_clear();
lcd_goto(0);
lcd_puts("Lock Closed");

k++;
if(k==3)
{
TRISC=0x00;
PORTC=0x02;
DelayMs(5000);
PORTC=0x00;
k=0;
}
}
}
else if(e==0)
{
if(pwd==pwd1)
{
ad=0x44;
count=4;
lcd_clear();
lcd_goto(0);
lcd_puts("New Password");
lcd_goto(ad);
e=2;
}
else
{
ad=0x44;
lcd_clear();
lcd_goto(0);
lcd_puts("Password Denied");
DelayMs(2000);
count=4;
e=0;
lcd_clear();
lcd_goto(0);
lcd_puts("Current password");
lcd_goto(ad);
}
}
else if (e==2)
{
pwdwrite(pwd);
pwd1=pwdread();
lcd_clear();
lcd_goto(0);
lcd_puts("Password Saved");
DelayMs(2000);
lcd_clear();
lcd_goto(0);
lcd_puts("Welcome");
}
}
}
if(row==4 && col==4)
{
if(lock==1)
{
ad=0x44;
count=4;
e=1;
lcd_clear();
lcd_goto(0);
lcd_puts("Enter Password");
lcd_goto(ad);
}
else
{
lcd_clear();
lcd_goto(0);
lcd_puts("Already Open");
DelayMs(2000);
lcd_clear();
lcd_goto(0);
lcd_puts("Lock Open");
}
}
}